#include <fstream>
#include <vector>
#include <string>

#include <GL/glew.h>
#include "texture.h"

class obj
{
public:
	class vert
	{
	public:
		float x;
		float y;
		float z;
	};
	class poly
	{
	public:
		int p[3];
	};
	std::vector<vert> verts;
	std::vector<poly> polys;
	obj(const std::string filename)
	{
		auto file = std::ifstream(filename);
		while (file.good())
			if (file.get() == '\n')
			{
				switch (file.get())
				{
				case 'v':
					verts.push_back(vert());
					file >> verts.back().x >> verts.back().y >> verts.back().z;
					break;
				case 'f':
					poly pa;
					poly pb;
					polys.push_back(poly());
					file >> pa.p[0] >> pa.p[1] >> pa.p[2] >> pb.p[2];
					pb.p[0] = pa.p[0];
					pb.p[1] = pa.p[2];
					polys.push_back(pa);
					polys.push_back(pb);
					break;
				}
			}
	}
	gl::texture gen_vert_tex()
	{
		int w = (int)sqrt((double)verts.size());
		int h = (verts.size()+w-1)/w;
		verts.reserve(w*h);
		return gl::texture(GL_TEXTURE_RECTANGLE).size(w,h).format(GL_RGB32F).load_image(GL_RGB,GL_FLOAT,verts.data());
	}
	gl::texture gen_poly_tex()
	{
		int w = (int)sqrt((double)polys.size());
		int h = (polys.size()+w-1)/w;
		polys.reserve(w*h);
		return gl::texture(GL_TEXTURE_RECTANGLE).size(w,h).format(GL_RGB32I).load_image(GL_RGB,GL_INT,polys.data());
	}

};