#include "shader.h"
#include <utility>
#include <string.h>
#include <stdio.h>

namespace glsl
{
	shader::shader(const char* source, GLenum type)
		: id(glCreateShader(type))
	{ 
		char log[1<<12];
		int slength = strlen(source); 
		//dprintf("shader %d created\n", id);
		glShaderSource(id, 1, &source, &slength);
		glCompileShader(id);
		glGetShaderInfoLog(id, 1024, &slength, log);
		log[slength] = 0;
		dprintf("shader %d compile log:\n%s", id, log);
	}
	shader shader::from_file(const char* filename, GLenum type)
	{
		FILE* fin = fopen(filename, "rb");

		if (fin == NULL)
		{
			wchar_t pathbuf[1024];
			GetCurrentDirectoryW(1024,pathbuf);
			//dprintf("file '%s/%s' not found\n", pathbuf,filename);
			return shader();
		}

		fseek(fin,0,SEEK_END);
		long size = ftell(fin);
		char* buffer = new char[size+1];
		fseek(fin,0,SEEK_SET);
		fread(buffer, 1, size, fin);
		buffer[size] = 0;

		//dprintf("shader from file %s\n", filename);
		shader sh(buffer, type);

		fclose(fin);

		return std::move(sh);
	}
	program program::link() 
	{ 
		char log[1024];
		int slength;
		glLinkProgram(id); 
		//glGetProgramInfoLog(id, 1024, &slength, log);
		//log[slength] = 0;
		//dprintf("program link log:\n%s", log);
		return std::move(*this);
	}
}
